/*  przyklad tworzenia MEX-pliku    (DOS lub UNIX)
    do kompilacji zastosowano    mex ode1000.c

**************************************************
* % oryginalny  M-plik  przetwarzany na MEX-plik *
* function xdot=ode1000(t,x)                     *
* xdot=zeros(2,1);        % macierz zerowa:      *
* xdot(1)=x(2);           % rownania rozniczkowe *
* xdot(2)=-1001*x(2) -1000*x(1);                 *
**************************************************/

#include <math.h>
#include "mex.h"        /* biblioteka MATLAB-a */

/* parametry wejsciowe (prawa strona) */
#define t_in    prhs[0]
#define x_in    prhs[1]

/* parametry wyjsciowe (lewa strona) */
#define xdot_out  plhs[0]
static
ode1000( double  xdot[], double  *t, double  x[] )
{       xdot[0] =                  x[1];
        xdot[1] = -1000*x[0] -1001*x[1] ;
        return;}
 /* ============= Gateway: interfejs do MATLAB-a ============== */
void mexFunction(int nlhs, mxArray *plhs[],
            int nrhs, const mxArray *prhs[])
{
        double  *xdot;
        double  *t,*x;
        unsigned int    m,n;

/****** kontrola poprawnej liczby parametrow formalnych ******/
        if (nrhs != 2)
        {
        mexErrMsgTxt( "ode1000 wymaga 2 parametrow wejsciowych " );
        } else if (nlhs > 1)
        {
        mexErrMsgTxt( " ode1000 wymaga 1 parametru wyjsciowego" );
        }
/******* kontrola poprawnosci rozmiarow macierzy x_in ********/
        m = mxGetM(x_in);
        n = mxGetN(x_in);
        if (!mxIsNumeric(x_in) || mxIsComplex(x_in) ||
          mxIsSparse(x_in)  || !mxIsDouble(x_in) && 
          ((m==1&&n==2) || (n==2 &&m==1)) ) /*2x1 lub 1x2.*/
  {mexErrMsgTxt(" ode1000 wymaga aby x_in mialo wymiar 2x1.");
  }
/******* utworzenie macierzy dla rezultatow obliczen *********/
        xdot_out = mxCreateDoubleMatrix(m, n, mxREAL);
        /* przypisanie wskaznikow do parametrow */
        xdot = mxGetPr(xdot_out);
        t = mxGetPr(t_in);
        x = mxGetPr(x_in);
/*********** wykonanie obliczen ***********/
        ode1000(xdot,t,x);
        return;
}
